Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::StaticGeometry::GeometryBucket Class Reference

A GeometryBucket is a the lowest level bucket where geometry with the same vertex & index format is stored. More...

`#include <OgreStaticGeometry.h>`

Inheritance diagram for Ogre::StaticGeometry::GeometryBucket:

[legend]
List of all members.

## Public Member Functions
| GeometryBucket (MaterialBucket *parent, const String &formatString, const VertexData *vData, const IndexData *iData)
virtual | ~GeometryBucket ()
MaterialBucket * | getParent (void)
const VertexData * | getVertexData (void) const
| Get the vertex data for this geometry.
const IndexData * | getIndexData (void) const
| Get the index data for this geometry.
const MaterialPtr & | getMaterial (void) const
| Remarks: Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available.
Technique * | getTechnique (void) const
| Retrieves a pointer to the Material Technique this renderable object uses.
void | getRenderOperation (RenderOperation &op)
| Gets the render operation required to send this object to the frame buffer.
void | getWorldTransforms (Matrix4 *xform) const
| Gets the world transform matrix / matrices for this renderable object.
const Quaternion & | getWorldOrientation (void) const
| Gets the worldspace orientation of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.
const Vector3 & | getWorldPosition (void) const
| Gets the worldspace position of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling.
Real | getSquaredViewDepth (const Camera *cam) const
| Returns the camera-relative squared depth of this renderable.
const LightList & | getLights (void) const
| Gets a list of lights, ordered relative to how close they are to this renderable.
bool | getCastsShadows (void) const
| Method which reports whether this renderable would normally cast a shadow.
bool | assign (QueuedGeometry *qsm)
| Try to assign geometry to this bucket.
void | build (bool stencilShadows)
| Build.
void | dump (std::ofstream &of) const
| Dump contents for diagnostics.
virtual unsigned short | getNumWorldTransforms (void) const
| Returns the number of world transform matrices this renderable requires.
void | setUseIdentityProjection (bool useIdentityProjection)
| Sets whether or not to use an 'identity' projection.
bool | getUseIdentityProjection (void) const
| Returns whether or not to use an 'identity' projection.
void | setUseIdentityView (bool useIdentityView)
| Sets whether or not to use an 'identity' view.
bool | getUseIdentityView (void) const
| Returns whether or not to use an 'identity' view.
virtual bool | getNormaliseNormals (void) const
| Returns whether or not this Renderable wishes the hardware to normalise normals.
virtual const PlaneList & | getClipPlanes () const
void | setCustomParameter (size_t index, const Vector4 &value)
| Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters.
const Vector4 & | getCustomParameter (size_t index) const
| Gets the custom value associated with this Renderable at the given index.
virtual void | _updateCustomGpuParameter (const GpuProgramParameters::AutoConstantEntry &constantEntry, GpuProgramParameters *params) const
| Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows.
virtual void | setPolygonModeOverrideable (bool override)
| Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
virtual bool | getPolygonModeOverrideable (void) const
| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting.
## Protected Types
typedef std::map< size_t, Vector4 > | CustomParameterMap
## Protected Member Functions
template<typename T>
void | copyIndexes (const T *src, T *dst, size_t count, size_t indexOffset)
## Protected Attributes
QueuedGeometryList | mQueuedGeometry
| Geometry which has been queued up pre-build (not for deallocation).
MaterialBucket * | mParent
| Pointer to parent bucket.
String | mFormatString
| String identifying the vertex / index format.
VertexData * | mVertexData
| Vertex information, includes current number of vertices committed to be a part of this bucket.
IndexData * | mIndexData
| Index information, includes index type which limits the max number of vertices which are allowed in one bucket.
HardwareIndexBuffer::IndexType | mIndexType
| Size of indexes.
size_t | mMaxVertexIndex
| Maximum vertex indexable.
CustomParameterMap | mCustomParameters
bool | mPolygonModeOverrideable
bool | mUseIdentityProjection
bool | mUseIdentityView
## Static Protected Attributes
static const PlaneList | msDummyPlaneList

## Detailed Description

A GeometryBucket is a the lowest level bucket where geometry with the same vertex & index format is stored.

It also acts as the renderable.

Definition at line 183 of file OgreStaticGeometry.h.

## Member Typedef Documentation

typedef std::map<size_t, Vector4> Ogre::Renderable::CustomParameterMap`[protected, inherited]`

| Definition at line 285 of file OgreRenderable.h.

## Constructor & Destructor Documentation

Ogre::StaticGeometry::GeometryBucket::GeometryBucket | ( | MaterialBucket * | parent,
|  | const String & | formatString,
|  | const VertexData * | vData,
|  | const IndexData * | iData
| ) |

virtual Ogre::StaticGeometry::GeometryBucket::~GeometryBucket | ( |  | ) | `[virtual]`

## Member Function Documentation

virtual void Ogre::Renderable::_updateCustomGpuParameter | ( | const GpuProgramParameters::AutoConstantEntry & | constantEntry,
|  | GpuProgramParameters * | params
| ) | const`[virtual, inherited]`

  | Update a custom GpuProgramParameters constant which is derived from information only this Renderable knows. Remarks: This method allows a Renderable to map in a custom GPU program parameter based on it's own data. This is represented by a GPU auto parameter of ACT_CUSTOM, and to allow there to be more than one of these per Renderable, the 'data' field on the auto parameter will identify which parameter is being updated. The implementation of this method must identify the parameter being updated, and call a 'setConstant' method on the passed in GpuProgramParameters object, using the details provided in the incoming auto constant setting to identify the index at which to set the parameter. You do not need to override this method if you're using the standard sets of data associated with the Renderable as provided by setCustomParameter and getCustomParameter. By default, the implementation will map from the value indexed by the 'constantEntry.data' parameter to a value previously set by setCustomParameter. But custom Renderables are free to override this if they want, in any case. Parameters:
  | constantEntry | The auto constant entry referring to the parameter being updated
  | params | The parameters object which this method should call to set the updated parameters.
Reimplemented in Ogre::SubEntity. Definition at line 252 of file OgreRenderable.h.

bool Ogre::StaticGeometry::GeometryBucket::assign | ( | QueuedGeometry * | qsm | ) |

| Try to assign geometry to this bucket. Returns: false if there is no room left in this bucket

void Ogre::StaticGeometry::GeometryBucket::build | ( | bool | stencilShadows | ) |

| Build.

template<typename T>
void Ogre::StaticGeometry::GeometryBucket::copyIndexes | ( | const T * | src,
|  | T * | dst,
|  | size_t | count,
|  | size_t | indexOffset
| ) | `[protected]`

| Definition at line 204 of file OgreStaticGeometry.h.

void Ogre::StaticGeometry::GeometryBucket::dump | ( | std::ofstream & | of | ) | const

| Dump contents for diagnostics.

bool Ogre::StaticGeometry::GeometryBucket::getCastsShadows | ( | void |  | ) | const`[virtual]`

| Method which reports whether this renderable would normally cast a shadow. Remarks: Subclasses should override this if they could have been used to generate a shadow. Reimplemented from Ogre::Renderable.

virtual const PlaneList& Ogre::Renderable::getClipPlanes | ( |  | ) | const`[virtual, inherited]`

| Definition at line 179 of file OgreRenderable.h.

const Vector4& Ogre::Renderable::getCustomParameter | ( | size_t | index | ) | const`[inherited]`

  | Gets the custom value associated with this Renderable at the given index. Parameters:
  | @see | setCustomParaemter for full details.
Definition at line 213 of file OgreRenderable.h. References OGRE_EXCEPT.

const IndexData* Ogre::StaticGeometry::GeometryBucket::getIndexData | ( | void |  | ) | const

| Get the index data for this geometry. Definition at line 226 of file OgreStaticGeometry.h.

const LightList& Ogre::StaticGeometry::GeometryBucket::getLights | ( | void |  | ) | const`[virtual]`

| Gets a list of lights, ordered relative to how close they are to this renderable. Remarks: Directional lights, which have no position, will always be first on this list. Implements Ogre::Renderable.

const MaterialPtr& Ogre::StaticGeometry::GeometryBucket::getMaterial | ( | void |  | ) | const`[virtual]`

| Remarks: Note that the Renderable also has the option to override the getTechnique method to specify a particular Technique to use instead of the best one available. Implements Ogre::Renderable.

virtual bool Ogre::Renderable::getNormaliseNormals | ( | void |  | ) | const`[virtual, inherited]`

| Returns whether or not this Renderable wishes the hardware to normalise normals. Reimplemented in Ogre::SubEntity. Definition at line 171 of file OgreRenderable.h.

virtual unsigned short Ogre::Renderable::getNumWorldTransforms | ( | void |  | ) | const`[virtual, inherited]`

| Returns the number of world transform matrices this renderable requires. Remarks: When a renderable uses vertex blending, it uses multiple world matrices instead of a single one. Each vertex sent to the pipeline can reference one or more matrices in this list with given weights. If a renderable does not use vertex blending this method returns 1, which is the default for simplicity. Reimplemented in Ogre::BorderRenderable, Ogre::InstancedGeometry::GeometryBucket, and Ogre::SubEntity. Definition at line 111 of file OgreRenderable.h.

MaterialBucket* Ogre::StaticGeometry::GeometryBucket::getParent | ( | void |  | ) |

| Definition at line 222 of file OgreStaticGeometry.h.

virtual bool Ogre::Renderable::getPolygonModeOverrideable | ( | void |  | ) | const`[virtual, inherited]`

| Gets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Reimplemented in Ogre::BorderRenderable. Definition at line 277 of file OgreRenderable.h.

void Ogre::StaticGeometry::GeometryBucket::getRenderOperation | ( | RenderOperation & | op | ) | `[virtual]`

| Gets the render operation required to send this object to the frame buffer. Implements Ogre::Renderable.

Real Ogre::StaticGeometry::GeometryBucket::getSquaredViewDepth | ( | const Camera * | cam | ) | const`[virtual]`

| Returns the camera-relative squared depth of this renderable. Remarks: Used to sort transparent objects. Squared depth is used rather than actual depth to avoid having to perform a square root on the result. Implements Ogre::Renderable.

Technique* Ogre::StaticGeometry::GeometryBucket::getTechnique | ( | void |  | ) | const`[virtual]`

| Retrieves a pointer to the Material Technique this renderable object uses. Remarks: This is to allow Renderables to use a chosen Technique if they wish, otherwise they will use the best Technique available for the Material they are using. Reimplemented from Ogre::Renderable.

bool Ogre::Renderable::getUseIdentityProjection | ( | void |  | ) | const`[inherited]`

| Returns whether or not to use an 'identity' projection. Remarks: Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. See also: Renderable::setUseIdentityProjection Definition at line 136 of file OgreRenderable.h.

bool Ogre::Renderable::getUseIdentityView | ( | void |  | ) | const`[inherited]`

| Returns whether or not to use an 'identity' view. Remarks: Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. See also: Renderable::setUseIdentityView Definition at line 161 of file OgreRenderable.h.

const VertexData* Ogre::StaticGeometry::GeometryBucket::getVertexData | ( | void |  | ) | const

| Get the vertex data for this geometry. Definition at line 224 of file OgreStaticGeometry.h.

const Quaternion& Ogre::StaticGeometry::GeometryBucket::getWorldOrientation | ( | void |  | ) | const`[virtual]`

| Gets the worldspace orientation of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling. Implements Ogre::Renderable.

const Vector3& Ogre::StaticGeometry::GeometryBucket::getWorldPosition | ( | void |  | ) | const`[virtual]`

| Gets the worldspace position of this renderable; this is used in order to more efficiently update parameters to vertex & fragment programs, since inverting Quaterion and Vector in order to derive object-space positions / directions for cameras and lights is much more efficient than inverting a complete 4x4 matrix, and also eliminates problems introduced by scaling. Implements Ogre::Renderable.

void Ogre::StaticGeometry::GeometryBucket::getWorldTransforms | ( | Matrix4 * | xform | ) | const`[virtual]`

| Gets the world transform matrix / matrices for this renderable object. Remarks: If the object has any derived transforms, these are expected to be up to date as long as all the SceneNode structures have been updated before this is called. This method will populate xform with 1 matrix if it does not use vertex blending. If it does use vertex blending it will fill the passed in pointer with an array of matrices, the length being the value returned from getNumWorldTransforms. Note: Internal Ogre never supports non-affine matrix for world transform matrix/matrices, the behavior is undefined if returns non-affine matrix here. See also: Matrix4::isAffine. Implements Ogre::Renderable.

void Ogre::Renderable::setCustomParameter | ( | size_t | index,
|  | const Vector4 & | value
| ) | `[inherited]`

  | Sets a custom parameter for this Renderable, which may be used to drive calculations for this specific Renderable, like GPU program parameters. Remarks: Calling this method simply associates a numeric index with a 4-dimensional value for this specific Renderable. This is most useful if the material which this Renderable uses a vertex or fragment program, and has an ACT_CUSTOM parameter entry. This parameter entry can refer to the index you specify as part of this call, thereby mapping a custom parameter for this renderable to a program parameter. Parameters:
  | index | The index with which to associate the value. Note that this does not have to start at 0, and can include gaps. It also has no direct correlation with a GPU program parameter index - the mapping between the two is performed by the ACT_CUSTOM entry, if that is used.
  | value | The value to associate.
Definition at line 204 of file OgreRenderable.h.

virtual void Ogre::Renderable::setPolygonModeOverrideable | ( | bool | override | ) | `[virtual, inherited]`

  | Sets whether this renderable's chosen detail level can be overridden (downgraded) by the camera setting. Parameters:
  | override | true means that a lower camera detail will override this renderables detail level, false means it won't.
Definition at line 269 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityProjection | ( | bool | useIdentityProjection | ) | `[inherited]`

| Sets whether or not to use an 'identity' projection. Remarks: Usually Renderable objects will use a projection matrix as determined by the active camera. However, if they want they can cancel this out and use an identity projection, which effectively projects in 2D using a {-1, 1} view space. Useful for overlay rendering. Normal renderables need not change this. The default is false. See also: Renderable::getUseIdentityProjection Definition at line 122 of file OgreRenderable.h.

void Ogre::Renderable::setUseIdentityView | ( | bool | useIdentityView | ) | `[inherited]`

| Sets whether or not to use an 'identity' view. Remarks: Usually Renderable objects will use a view matrix as determined by the active camera. However, if they want they can cancel this out and use an identity matrix, which means all geometry is assumed to be relative to camera space already. Useful for overlay rendering. Normal renderables need not change this. The default is false. See also: Renderable::getUseIdentityView Definition at line 147 of file OgreRenderable.h.

## Member Data Documentation

CustomParameterMap Ogre::Renderable::mCustomParameters`[protected, inherited]`

| Definition at line 286 of file OgreRenderable.h.

String Ogre::StaticGeometry::GeometryBucket::mFormatString`[protected]`

| String identifying the vertex / index format. Definition at line 191 of file OgreStaticGeometry.h.

IndexData* Ogre::StaticGeometry::GeometryBucket::mIndexData`[protected]`

| Index information, includes index type which limits the max number of vertices which are allowed in one bucket. Definition at line 197 of file OgreStaticGeometry.h.

HardwareIndexBuffer::IndexType Ogre::StaticGeometry::GeometryBucket::mIndexType`[protected]`

| Size of indexes. Definition at line 199 of file OgreStaticGeometry.h.

size_t Ogre::StaticGeometry::GeometryBucket::mMaxVertexIndex`[protected]`

| Maximum vertex indexable. Definition at line 201 of file OgreStaticGeometry.h.

MaterialBucket* Ogre::StaticGeometry::GeometryBucket::mParent`[protected]`

| Pointer to parent bucket. Definition at line 189 of file OgreStaticGeometry.h.

bool Ogre::Renderable::mPolygonModeOverrideable`[protected, inherited]`

| Definition at line 287 of file OgreRenderable.h.

QueuedGeometryList Ogre::StaticGeometry::GeometryBucket::mQueuedGeometry`[protected]`

| Geometry which has been queued up pre-build (not for deallocation). Definition at line 187 of file OgreStaticGeometry.h.

const PlaneList Ogre::Renderable::msDummyPlaneList`[static, protected, inherited]`

| Definition at line 284 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityProjection`[protected, inherited]`

| Definition at line 288 of file OgreRenderable.h.

bool Ogre::Renderable::mUseIdentityView`[protected, inherited]`

| Definition at line 289 of file OgreRenderable.h.

VertexData* Ogre::StaticGeometry::GeometryBucket::mVertexData`[protected]`

| Vertex information, includes current number of vertices committed to be a part of this bucket. Definition at line 194 of file OgreStaticGeometry.h.

The documentation for this class was generated from the following file:

- OgreStaticGeometry.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:49:07 2008